"""
"   Copyright (C) Artila Electronics Co., Ltd. All Rights Reserved.
"
"	Description: 
"		Example for serial loopback test.
"
"""
import serial
import struct
import sys
import time

LOOPBACK = 1
msg = "Star Trek is an American science fiction entertainment franchise " \
       "created by Gene Roddenberry and owned by CBS and Paramount Pictures."
       
def serial_connect(port, baud, timeout):
    """
    IN:
        port: serial port (ex. COM19 or /dev/ttyS1)
        baud: serial port baudrate
        time out: second
    OUT:
        serial hadler
    """
    try:
        ser = serial.Serial(
            port,
            baudrate = baud,
            parity = "N",
            stopbits = 1,
            bytesize = 8,
            timeout = timeout
        )
    except:
        print "Can't open device", port
        sys.exit(1)

    return ser

if __name__ == "__main__":
    PORT = "/dev/ttyS1"
    BAUD = 115200
    
    if(len(sys.argv) > 2):
        port = int(sys.argv[1])
        if(port > 4):
            PORT = "/dev/ttyUSB%d" % (port - 5)
        else:
            PORT = "/dev/ttyS%d" % port
        BAUD = sys.argv[2]
      
    print PORT, BAUD
    ser = serial_connect(PORT, BAUD, 1)
   
    ## loopback test
    if(LOOPBACK):
        ser.write(msg)
        
    while(True):
        try:
            response = ser.readline()
            print("read data: " + response)
            if(len(response) > 0):
                ser.write(response)
        except:
            print "exit"
            ser.close()
            sys.exit(1)

    ser.close()