/********************************************************************
 *  Copyright (C) Artila Electronics Co., Ltd. All Rights Reserved.
 *
 *	Description: 
 *		Example for serial loopback test.
 *	
 *********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stropts.h>

#include <sys/ioctl.h>
#include <asm/ioctls.h>
#include <linux/ioctl.h>

#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>

int main(int argc, char *argv[]){
	int fd = -1, speed = 115200;
    char buff[512];
	int nread;
    char *messages = "Hello world!!";
    char port[] = "/dev/ttyS1";

	printf("Open %s\n", port);
	fd = open(port, O_RDWR | O_NOCTTY | O_NDELAY);

	if (fd == -1) {
		printf("open %s Failed, errno: %d\r\n", port, errno);
		return 0;
	}
	
	// send data
    printf("Send: %s\n" ,messages);
    write(fd, messages, strlen(messages));
    sleep(1);

    while(1) {
		nread = read(fd, buff, sizeof(buff));
		if (nread > 0) {
			buff[nread] = '\0';
			//printf("Recv %d total\n", nread);
			printf("Recv: %s\n", buff);
            write(fd, buff, strlen(buff));
            sleep(1);
		}
	}
    
	close(fd);	
	
	return 0;
}
